Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms
Imports System.IO
Imports ColorCode
Imports SelectPdf

Namespace SelectPdf.Samples
    Partial Public Class PageBreaks
        Inherits Form

        Private Sub BtnCreatePdf_Click(sender As Object, e As EventArgs) Handles BtnCreatePdf.Click
            Dim renderingEngine As RenderingEngine = CType([Enum].Parse(GetType(RenderingEngine), DdlRenderingEngine.SelectedItem.ToString(), True), RenderingEngine)
            Cursor = Cursors.WaitCursor
            Dim file As String = "Document.pdf"

            Try
                ' read parameters from the webpage
                Dim htmlString As String = TxtHtmlCode.Text
                Dim baseUrl As String = TxtBaseUrl.Text

                ' instantiate a html to pdf converter object
                Dim converter As New HtmlToPdf()
                converter.Options.RenderingEngine = renderingEngine

                converter.Options.MarginTop = 10
                converter.Options.MarginBottom = 10
                converter.Options.MarginLeft = 10
                converter.Options.MarginRight = 10

                ' create a new pdf document converting an url
                Dim doc As PdfDocument = converter.ConvertHtmlString(htmlString, baseUrl)

                ' save pdf document
                doc.Save(file)

                ' close pdf document
                doc.Close()
            Catch ex As Exception
                MessageBox.Show([String].Format("Error: {0}", ex.Message), "Error", _
                                MessageBoxButtons.OK, MessageBoxIcon.[Error])
                Return
            Finally
                Cursor = Cursors.Arrow
            End Try

            ' open generated pdf
            Try
                System.Diagnostics.Process.Start(file)
            Catch
                MessageBox.Show("Could not open generated pdf document", "Error", _
                                MessageBoxButtons.OK, MessageBoxIcon.[Error])
            End Try
        End Sub
        Public Sub New()
            InitializeComponent()
            TxtHtmlCode.Text = Helper.PageBreaksText()

            Try
                ' display highlighted sample code
                Dim code As String = Helper.ReadSourceCode("PageBreaks.vb")
                WBSampleCode.DocumentText = New CodeColorizer().Colorize(code, Languages.VbDotNet)
            Catch
                WBSampleCode.DocumentText = "Sample code not available"
            End Try
        End Sub

        Private Sub TxtHtmlCode_KeyDown(sender As Object, e As KeyEventArgs) _
            Handles TxtHtmlCode.KeyDown
            If e.Control AndAlso e.KeyCode = Keys.A Then
                TxtHtmlCode.SelectAll()
                e.SuppressKeyPress = True
            End If
        End Sub

    End Class
End Namespace
